'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _d3StateVisualizer = require('d3-state-visualizer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var wrapperStyle = {
  width: '100%',
  height: '100%'
};

var Chart = function (_Component) {
  _inherits(Chart, _Component);

  function Chart() {
    _classCallCheck(this, Chart);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Chart.prototype.componentDidMount = function componentDidMount() {
    var _props = this.props;
    var select = _props.select;
    var state = _props.state;
    var defaultIsVisible = _props.defaultIsVisible;

    this.renderChart = (0, _d3StateVisualizer.tree)((0, _reactDom.findDOMNode)(this), this.props);
    if (defaultIsVisible) {
      this.renderChart(select(state));
    }
  };

  Chart.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var state = nextProps.state;
    var select = nextProps.select;
    var monitorState = nextProps.monitorState;

    if (monitorState.isVisible !== false) {
      this.renderChart(select(state));
    }
  };

  Chart.prototype.render = function render() {
    return _react2.default.createElement('div', { style: wrapperStyle });
  };

  return Chart;
}(_react.Component);

Chart.propTypes = {
  state: _propTypes2.default.object,
  rootKeyName: _propTypes2.default.string,
  pushMethod: _propTypes2.default.oneOf(['push', 'unshift']),
  tree: _propTypes2.default.shape({
    name: _propTypes2.default.string,
    children: _propTypes2.default.array
  }),
  id: _propTypes2.default.string,
  style: _propTypes2.default.shape({
    node: _propTypes2.default.shape({
      colors: _propTypes2.default.shape({
        'default': _propTypes2.default.string,
        parent: _propTypes2.default.string,
        collapsed: _propTypes2.default.string
      }),
      radius: _propTypes2.default.number
    }),
    text: _propTypes2.default.shape({
      colors: _propTypes2.default.shape({
        'default': _propTypes2.default.string,
        hover: _propTypes2.default.string
      })
    }),
    link: _propTypes2.default.object
  }),
  size: _propTypes2.default.number,
  aspectRatio: _propTypes2.default.number,
  margin: _propTypes2.default.shape({
    top: _propTypes2.default.number,
    right: _propTypes2.default.number,
    bottom: _propTypes2.default.number,
    left: _propTypes2.default.number
  }),
  isSorted: _propTypes2.default.bool,
  heightBetweenNodesCoeff: _propTypes2.default.number,
  widthBetweenNodesCoeff: _propTypes2.default.number,
  transitionDuration: _propTypes2.default.number,
  onClickText: _propTypes2.default.func,
  tooltipOptions: _propTypes2.default.shape({
    disabled: _propTypes2.default.bool,
    left: _propTypes2.default.number,
    top: _propTypes2.default.number,
    offset: _propTypes2.default.shape({
      left: _propTypes2.default.number,
      top: _propTypes2.default.number
    }),
    indentationSize: _propTypes2.default.number,
    style: _propTypes2.default.object
  })
};
exports.default = Chart;